##// END OF EJS Templates
fix: iptables needs iptables-persistent package...
Unknown -
r286:106e6de7e0bf
parent child
Show More
@@ -1,774 +1,774
1 1 #!/bin/sh
2 2
3 3 ########################################################################
4 4 # rpi23-gen-image.sh 2015-2017
5 5 #
6 6 # Advanced Debian "jessie", "stretch" and "buster" bootstrap script for RPi2/3
7 7 #
8 8 # This program is free software; you can redistribute it and/or
9 9 # modify it under the terms of the GNU General Public License
10 10 # as published by the Free Software Foundation; either version 2
11 11 # of the License, or (at your option) any later version.
12 12 #
13 13 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
14 14 #
15 15 # Big thanks for patches and enhancements by 20+ github contributors!
16 16 ########################################################################
17 17
18 18 # Are we running as root?
19 19 if [ "$(id -u)" -ne "0" ] ; then
20 20 echo "error: this script must be executed with root privileges!"
21 21 exit 1
22 22 fi
23 23
24 24 # Check if ./functions.sh script exists
25 25 if [ ! -r "./functions.sh" ] ; then
26 26 echo "error: './functions.sh' required script not found!"
27 27 exit 1
28 28 fi
29 29
30 30 # Load utility functions
31 31 . ./functions.sh
32 32
33 33 # Load parameters from configuration template file
34 34 if [ ! -z "$CONFIG_TEMPLATE" ] ; then
35 35 use_template
36 36 fi
37 37
38 38 # Introduce settings
39 39 set -e
40 40 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
41 41 set -x
42 42
43 43 # Raspberry Pi model configuration
44 44 RPI_MODEL=${RPI_MODEL:=2}
45 45
46 46 #bcm2708-rpi-0-w.dtb (Used for Pi 0 and PI 0W)
47 47 RPI0_DTB_FILE=${RPI0_DTB_FILE:=bcm2708-rpi-0-w.dtb}
48 48 RPI0_UBOOT_CONFIG=${RPI0_UBOOT_CONFIG:=rpi_defconfig}
49 49
50 50 #bcm2708-rpi-b.dtb (Used for Pi 1 model A and B)
51 51 RPI1_DTB_FILE=${RPI1_DTB_FILE:=bcm2708-rpi-b.dtb}
52 52 RPI1_UBOOT_CONFIG=${RPI1_UBOOT_CONFIG:=rpi_defconfig}
53 53
54 54 #bcm2708-rpi-b-plus.dtb (Used for Pi 1 model B+ and A+)
55 55 RPI1P_DTB_FILE=${RPI1P_DTB_FILE:=bcm2708-rpi-b-plus.dtb}
56 56 RPI1P_UBOOT_CONFIG=${RPI1P_UBOOT_CONFIG:=rpi_defconfig}
57 57
58 58 #bcm2709-rpi-2-b.dtb (Used for Pi 2 model B)
59 59 RPI2_DTB_FILE=${RPI2_DTB_FILE:=bcm2709-rpi-2-b.dtb}
60 60 RPI2_UBOOT_CONFIG=${RPI2_UBOOT_CONFIG:=rpi_2_defconfig}
61 61
62 62 #bcm2710-rpi-3-b.dtb (Used for Pi 3 model B)
63 63 RPI3_DTB_FILE=${RPI3_DTB_FILE:=bcm2710-rpi-3-b.dtb}
64 64 RPI3_UBOOT_CONFIG=${RPI3_UBOOT_CONFIG:=rpi_3_32b_defconfig}
65 65
66 66 #bcm2710-rpi-3-b-plus.dtb (Used for Pi 3 model B+)
67 67 RPI3P_DTB_FILE=${RPI3P_DTB_FILE:=bcm2710-rpi-3-b-plus.dtb}
68 68 RPI3P_UBOOT_CONFIG=${RPI3P_UBOOT_CONFIG:=rpi_3_32b_defconfig}
69 69
70 70 # Debian release
71 71 RELEASE=${RELEASE:=jessie}
72 72 KERNEL_ARCH=${KERNEL_ARCH:=arm}
73 73 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
74 74 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
75 75 COLLABORA_KERNEL=${COLLABORA_KERNEL:=3.18.0-trunk-rpi2}
76 76 if [ "$KERNEL_ARCH" = "arm64" ] ; then
77 77 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
78 78 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
79 79 fi
80 80
81 81 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
82 82 #RASPBERRY PI 1, PI ZERO, PI ZERO W, AND COMPUTE MODULE DEFAULT Kernel BUILD CONFIGURATION
83 83 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
84 84 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
85 85 else
86 86 #RASPBERRY PI 2, PI 3, PI 3+, AND COMPUTE MODULE 3 DEFAULT Kernel BUILD CONFIGURATION
87 87 #https://www.raspberrypi.org/documentation/linux/kernel/building.md
88 88 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
89 89 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
90 90 fi
91 91
92 92 if [ "$RELEASE_ARCH" = "arm64" ] ; then
93 93 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
94 94 else
95 95 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
96 96 fi
97 97 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
98 98
99 99 # URLs
100 100 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
101 101 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
102 102 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
103 103 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
104 104 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
105 105 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
106 106
107 107 # Build directories
108 108 BASEDIR=${BASEDIR:=$(pwd)/images/${RELEASE}}
109 109 BUILDDIR="${BASEDIR}/build"
110 110
111 111 # Prepare date string for default image file name
112 112 DATE="$(date +%Y-%m-%d)"
113 113 if [ -z "$KERNEL_BRANCH" ] ; then
114 114 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
115 115 else
116 116 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
117 117 fi
118 118
119 119 # Chroot directories
120 120 R="${BUILDDIR}/chroot"
121 121 ETC_DIR="${R}/etc"
122 122 LIB_DIR="${R}/lib"
123 123 BOOT_DIR="${R}/boot/firmware"
124 124 KERNEL_DIR="${R}/usr/src/linux"
125 125 WLAN_FIRMWARE_DIR="${R}/lib/firmware/brcm"
126 126
127 127 # Firmware directory: Blank if download from github
128 128 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
129 129
130 130 # General settings
131 131 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
132 132 PASSWORD=${PASSWORD:=raspberry}
133 133 USER_PASSWORD=${USER_PASSWORD:=raspberry}
134 134 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
135 135 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
136 136 EXPANDROOT=${EXPANDROOT:=true}
137 137
138 138 # Keyboard settings
139 139 XKB_MODEL=${XKB_MODEL:=""}
140 140 XKB_LAYOUT=${XKB_LAYOUT:=""}
141 141 XKB_VARIANT=${XKB_VARIANT:=""}
142 142 XKB_OPTIONS=${XKB_OPTIONS:=""}
143 143
144 144 # Network settings (DHCP)
145 145 ENABLE_DHCP=${ENABLE_DHCP:=true}
146 146
147 147 # Network settings (static)
148 148 NET_ADDRESS=${NET_ADDRESS:=""}
149 149 NET_GATEWAY=${NET_GATEWAY:=""}
150 150 NET_DNS_1=${NET_DNS_1:=""}
151 151 NET_DNS_2=${NET_DNS_2:=""}
152 152 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
153 153 NET_NTP_1=${NET_NTP_1:=""}
154 154 NET_NTP_2=${NET_NTP_2:=""}
155 155
156 156 # APT settings
157 157 APT_PROXY=${APT_PROXY:=""}
158 158 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
159 159
160 160 # Feature settings
161 161 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
162 162 ENABLE_I2C=${ENABLE_I2C:=false}
163 163 ENABLE_SPI=${ENABLE_SPI:=false}
164 164 ENABLE_IPV6=${ENABLE_IPV6:=true}
165 165 ENABLE_SSHD=${ENABLE_SSHD:=true}
166 166 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
167 167 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
168 168 ENABLE_SOUND=${ENABLE_SOUND:=true}
169 169 ENABLE_DBUS=${ENABLE_DBUS:=true}
170 170 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
171 171 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
172 172 ENABLE_XORG=${ENABLE_XORG:=false}
173 173 ENABLE_WM=${ENABLE_WM:=""}
174 174 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
175 175 ENABLE_USER=${ENABLE_USER:=true}
176 176 USER_NAME=${USER_NAME:="pi"}
177 177 ENABLE_ROOT=${ENABLE_ROOT:=false}
178 178 ENABLE_QEMU=${ENABLE_QEMU:=false}
179 179
180 180 # SSH settings
181 181 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
182 182 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
183 183 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
184 184 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
185 185 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
186 186
187 187 # Advanced settings
188 188 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
189 189 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
190 190 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
191 191 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
192 192 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
193 193 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
194 194 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
195 195 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
196 196 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
197 197 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
198 198 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
199 199 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
200 200
201 201 # Kernel compilation settings
202 202 BUILD_KERNEL=${BUILD_KERNEL:=false}
203 203 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
204 204 KERNEL_THREADS=${KERNEL_THREADS:=1}
205 205 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
206 206 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
207 207 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
208 208 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
209 209 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
210 210
211 211 if [ "$KERNEL_ARCH" = "arm64" ] ; then
212 212 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
213 213 else
214 214 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
215 215 fi
216 216
217 217 # Kernel compilation from source directory settings
218 218 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
219 219 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
220 220 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
221 221 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
222 222
223 223 # Reduce disk usage settings
224 224 REDUCE_APT=${REDUCE_APT:=true}
225 225 REDUCE_DOC=${REDUCE_DOC:=true}
226 226 REDUCE_MAN=${REDUCE_MAN:=true}
227 227 REDUCE_VIM=${REDUCE_VIM:=false}
228 228 REDUCE_BASH=${REDUCE_BASH:=false}
229 229 REDUCE_HWDB=${REDUCE_HWDB:=true}
230 230 REDUCE_SSHD=${REDUCE_SSHD:=true}
231 231 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
232 232
233 233 # Encrypted filesystem settings
234 234 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
235 235 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
236 236 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
237 237 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
238 238 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
239 239
240 240 # Chroot scripts directory
241 241 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
242 242
243 243 # Packages required in the chroot build environment
244 244 APT_INCLUDES=${APT_INCLUDES:=""}
245 245 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils"
246 246
247 247 # Packages required for bootstrapping
248 248 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
249 249 MISSING_PACKAGES=""
250 250
251 251 # Packages installed for c/c++ build environment in chroot (keep empty)
252 252 COMPILER_PACKAGES=""
253 253
254 254 set +x
255 255
256 256 # Set Raspberry Pi model specific configuration
257 257 if [ "$RPI_MODEL" = 0 ] ; then
258 258 DTB_FILE=${RPI0_DTB_FILE}
259 259 UBOOT_CONFIG=${RPI0_UBOOT_CONFIG}
260 260 elif [ "$RPI_MODEL" = 1 ] ; then
261 261 DTB_FILE=${RPI1_DTB_FILE}
262 262 UBOOT_CONFIG=${RPI1_UBOOT_CONFIG}
263 263 elif [ "$RPI_MODEL" = 1P ] ; then
264 264 DTB_FILE=${RPI1P_DTB_FILE}
265 265 UBOOT_CONFIG=${RPI1P_UBOOT_CONFIG}
266 266 elif [ "$RPI_MODEL" = 2 ] ; then
267 267 DTB_FILE=${RPI2_DTB_FILE}
268 268 UBOOT_CONFIG=${RPI2_UBOOT_CONFIG}
269 269 elif [ "$RPI_MODEL" = 3 ] ; then
270 270 DTB_FILE=${RPI3_DTB_FILE}
271 271 UBOOT_CONFIG=${RPI3_UBOOT_CONFIG}
272 272 elif [ "$RPI_MODEL" = 3P ] ; then
273 273 DTB_FILE=${RPI3P_DTB_FILE}
274 274 UBOOT_CONFIG=${RPI3P_UBOOT_CONFIG}
275 275 else
276 276 echo "error: Raspberry Pi model ${RPI_MODEL} is not supported!"
277 277 exit 1
278 278 fi
279 279
280 280 # Check if the internal wireless interface is supported by the RPi model
281 281 if [ "$ENABLE_WIRELESS" = true ] && ([ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 2 ]); then
282 282
283 283 echo "error: The selected Raspberry Pi model has no internal wireless interface"
284 284 exit 1
285 285 fi
286 286
287 287 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
288 288 if [ ! -z "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
289 289 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
290 290 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
291 291 exit 1
292 292 fi
293 293 fi
294 294
295 295 # Build RPi2/3 Linux kernel if required by Debian release
296 296 if [ "$RELEASE" = "stretch" ] || [ "$RELEASE" = "buster" ] ; then
297 297 BUILD_KERNEL=true
298 298 fi
299 299
300 300 # Add packages required for kernel cross compilation
301 301 if [ "$BUILD_KERNEL" = true ] ; then
302 302 if [ "$KERNEL_ARCH" = "arm" ] ; then
303 303 if [ "$RELEASE_ARCH" = "armel" ]; then
304 304 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
305 305 fi
306 306 if [ "$RELEASE_ARCH" = "armhf" ]; then
307 307 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
308 308 fi
309 309 fi
310 310 if [ "$RELEASE_ARCH" = "arm64" ]; then
311 311 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
312 312 fi
313 313 fi
314 314
315 315 # Add libncurses5 to enable kernel menuconfig
316 316 if [ "$KERNEL_MENUCONFIG" = true ] ; then
317 317 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses5-dev"
318 318 fi
319 319
320 320 # Add ccache compiler cache for (faster) kernel cross (re)compilation
321 321 if [ "$KERNEL_CCACHE" = true ] ; then
322 322 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
323 323 fi
324 324
325 325 # Add cryptsetup package to enable filesystem encryption
326 326 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
327 327 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
328 328 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
329 329
330 330 if [ -z "$CRYPTFS_PASSWORD" ] ; then
331 331 echo "error: no password defined (CRYPTFS_PASSWORD)!"
332 332 exit 1
333 333 fi
334 334 ENABLE_INITRAMFS=true
335 335 fi
336 336
337 337 # Add initramfs generation tools
338 338 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
339 339 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
340 340 fi
341 341
342 342 # Add device-tree-compiler required for building the U-Boot bootloader
343 343 if [ "$ENABLE_UBOOT" = true ] ; then
344 344 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex"
345 345 fi
346 346
347 347 # Check if root SSH (v2) public key file exists
348 348 if [ ! -z "$SSH_ROOT_PUB_KEY" ] ; then
349 349 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
350 350 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
351 351 exit 1
352 352 fi
353 353 fi
354 354
355 355 # Check if $USER_NAME SSH (v2) public key file exists
356 356 if [ ! -z "$SSH_USER_PUB_KEY" ] ; then
357 357 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
358 358 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
359 359 exit 1
360 360 fi
361 361 fi
362 362
363 363 # Check if all required packages are installed on the build system
364 364 for package in $REQUIRED_PACKAGES ; do
365 365 if [ "`dpkg-query -W -f='${Status}' $package`" != "install ok installed" ] ; then
366 366 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
367 367 fi
368 368 done
369 369
370 370 # If there are missing packages ask confirmation for install, or exit
371 371 if [ -n "$MISSING_PACKAGES" ] ; then
372 372 echo "the following packages needed by this script are not installed:"
373 373 echo "$MISSING_PACKAGES"
374 374
375 375 echo -n "\ndo you want to install the missing packages right now? [y/n] "
376 376 read confirm
377 377 [ "$confirm" != "y" ] && exit 1
378 378
379 379 # Make sure all missing required packages are installed
380 380 apt-get -qq -y install ${MISSING_PACKAGES}
381 381 fi
382 382
383 383 # Check if ./bootstrap.d directory exists
384 384 if [ ! -d "./bootstrap.d/" ] ; then
385 385 echo "error: './bootstrap.d' required directory not found!"
386 386 exit 1
387 387 fi
388 388
389 389 # Check if ./files directory exists
390 390 if [ ! -d "./files/" ] ; then
391 391 echo "error: './files' required directory not found!"
392 392 exit 1
393 393 fi
394 394
395 395 # Check if specified KERNELSRC_DIR directory exists
396 396 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
397 397 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
398 398 exit 1
399 399 fi
400 400
401 401 # Check if specified UBOOTSRC_DIR directory exists
402 402 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
403 403 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
404 404 exit 1
405 405 fi
406 406
407 407 # Check if specified FBTURBOSRC_DIR directory exists
408 408 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
409 409 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
410 410 exit 1
411 411 fi
412 412
413 413 # Check if specified CHROOT_SCRIPTS directory exists
414 414 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
415 415 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
416 416 exit 1
417 417 fi
418 418
419 419 # Check if specified device mapping already exists (will be used by cryptsetup)
420 420 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
421 421 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
422 422 exit 1
423 423 fi
424 424
425 425 # Don't clobber an old build
426 426 if [ -e "$BUILDDIR" ] ; then
427 427 echo "error: directory ${BUILDDIR} already exists, not proceeding"
428 428 exit 1
429 429 fi
430 430
431 431 # Setup chroot directory
432 432 mkdir -p "${R}"
433 433
434 434 # Check if build directory has enough of free disk space >512MB
435 435 if [ "$(df --output=avail ${BUILDDIR} | sed "1d")" -le "524288" ] ; then
436 436 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
437 437 exit 1
438 438 fi
439 439
440 440 set -x
441 441
442 442 # Call "cleanup" function on various signals and errors
443 443 trap cleanup 0 1 2 3 6
444 444
445 445 # Add required packages for the minbase installation
446 446 if [ "$ENABLE_MINBASE" = true ] ; then
447 447 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
448 448 fi
449 449
450 450 # Add required locales packages
451 451 if [ "$DEFLOCAL" != "en_US.UTF-8" ] ; then
452 452 APT_INCLUDES="${APT_INCLUDES},locales,keyboard-configuration,console-setup"
453 453 fi
454 454
455 455 # Add parted package, required to get partprobe utility
456 456 if [ "$EXPANDROOT" = true ] ; then
457 457 APT_INCLUDES="${APT_INCLUDES},parted"
458 458 fi
459 459
460 460 # Add dbus package, recommended if using systemd
461 461 if [ "$ENABLE_DBUS" = true ] ; then
462 462 APT_INCLUDES="${APT_INCLUDES},dbus"
463 463 fi
464 464
465 465 # Add iptables IPv4/IPv6 package
466 466 if [ "$ENABLE_IPTABLES" = true ] ; then
467 APT_INCLUDES="${APT_INCLUDES},iptables"
467 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
468 468 fi
469 469
470 470 # Add openssh server package
471 471 if [ "$ENABLE_SSHD" = true ] ; then
472 472 APT_INCLUDES="${APT_INCLUDES},openssh-server"
473 473 fi
474 474
475 475 # Add alsa-utils package
476 476 if [ "$ENABLE_SOUND" = true ] ; then
477 477 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
478 478 fi
479 479
480 480 # Add rng-tools package
481 481 if [ "$ENABLE_HWRANDOM" = true ] ; then
482 482 APT_INCLUDES="${APT_INCLUDES},rng-tools"
483 483 fi
484 484
485 485 # Add fbturbo video driver
486 486 if [ "$ENABLE_FBTURBO" = true ] ; then
487 487 # Enable xorg package dependencies
488 488 ENABLE_XORG=true
489 489 fi
490 490
491 491 # Add user defined window manager package
492 492 if [ -n "$ENABLE_WM" ] ; then
493 493 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
494 494
495 495 # Enable xorg package dependencies
496 496 ENABLE_XORG=true
497 497 fi
498 498
499 499 # Add xorg package
500 500 if [ "$ENABLE_XORG" = true ] ; then
501 501 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
502 502 fi
503 503
504 504 # Replace selected packages with smaller clones
505 505 if [ "$ENABLE_REDUCE" = true ] ; then
506 506 # Add levee package instead of vim-tiny
507 507 if [ "$REDUCE_VIM" = true ] ; then
508 508 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
509 509 fi
510 510
511 511 # Add dropbear package instead of openssh-server
512 512 if [ "$REDUCE_SSHD" = true ] ; then
513 513 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/openssh-server/dropbear/")"
514 514 fi
515 515 fi
516 516
517 517 if [ "$RELEASE" != "jessie" ] ; then
518 518 APT_INCLUDES="${APT_INCLUDES},libnss-systemd"
519 519 fi
520 520
521 521 # Configure kernel sources if no KERNELSRC_DIR
522 522 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
523 523 KERNELSRC_CONFIG=true
524 524 fi
525 525
526 526 # Configure reduced kernel
527 527 if [ "$KERNEL_REDUCE" = true ] ; then
528 528 KERNELSRC_CONFIG=false
529 529 fi
530 530
531 531 # Configure qemu compatible kernel
532 532 if [ "$ENABLE_QEMU" = true ] ; then
533 533 DTB_FILE=vexpress-v2p-ca15_a7.dtb
534 534 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
535 535 KERNEL_DEFCONFIG="vexpress_defconfig"
536 536 if [ "$KERNEL_MENUCONFIG" = false ] ; then
537 537 KERNEL_OLDDEFCONFIG=true
538 538 fi
539 539 fi
540 540
541 541 # Execute bootstrap scripts
542 542 for SCRIPT in bootstrap.d/*.sh; do
543 543 head -n 3 "$SCRIPT"
544 544 . "$SCRIPT"
545 545 done
546 546
547 547 ## Execute custom bootstrap scripts
548 548 if [ -d "custom.d" ] ; then
549 549 for SCRIPT in custom.d/*.sh; do
550 550 . "$SCRIPT"
551 551 done
552 552 fi
553 553
554 554 # Execute custom scripts inside the chroot
555 555 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
556 556 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
557 557 chroot_exec /bin/bash -x <<'EOF'
558 558 for SCRIPT in /chroot_scripts/* ; do
559 559 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
560 560 $SCRIPT
561 561 fi
562 562 done
563 563 EOF
564 564 rm -rf "${R}/chroot_scripts"
565 565 fi
566 566
567 567 # Remove c/c++ build environment from the chroot
568 568 chroot_remove_cc
569 569
570 570 # Remove apt-utils
571 571 if [ "$RELEASE" = "jessie" ] ; then
572 572 chroot_exec apt-get purge -qq -y --force-yes apt-utils
573 573 fi
574 574
575 575 # Generate required machine-id
576 576 MACHINE_ID=$(dbus-uuidgen)
577 577 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
578 578 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
579 579
580 580 # APT Cleanup
581 581 chroot_exec apt-get -y clean
582 582 chroot_exec apt-get -y autoclean
583 583 chroot_exec apt-get -y autoremove
584 584
585 585 # Unmount mounted filesystems
586 586 umount -l "${R}/proc"
587 587 umount -l "${R}/sys"
588 588
589 589 # Clean up directories
590 590 rm -rf "${R}/run/*"
591 591 rm -rf "${R}/tmp/*"
592 592
593 593 # Clean up files
594 594 rm -f "${ETC_DIR}/ssh/ssh_host_*"
595 595 rm -f "${ETC_DIR}/dropbear/dropbear_*"
596 596 rm -f "${ETC_DIR}/apt/sources.list.save"
597 597 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
598 598 rm -f "${ETC_DIR}/*-"
599 599 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
600 600 rm -f "${ETC_DIR}/resolv.conf"
601 601 rm -f "${R}/root/.bash_history"
602 602 rm -f "${R}/var/lib/urandom/random-seed"
603 603 rm -f "${R}/initrd.img"
604 604 rm -f "${R}/vmlinuz"
605 605 rm -f "${R}${QEMU_BINARY}"
606 606
607 607 if [ "$ENABLE_QEMU" = true ] ; then
608 608 # Setup QEMU directory
609 609 mkdir "${BASEDIR}/qemu"
610 610
611 611 # Copy kernel image to QEMU directory
612 612 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
613 613
614 614 # Copy kernel config to QEMU directory
615 615 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
616 616
617 617 # Copy kernel dtbs to QEMU directory
618 618 for dtb in "${BOOT_DIR}/"*.dtb ; do
619 619 if [ -f "${dtb}" ] ; then
620 620 install_readonly "${dtb}" "${BASEDIR}/qemu/"
621 621 fi
622 622 done
623 623
624 624 # Copy kernel overlays to QEMU directory
625 625 if [ -d "${BOOT_DIR}/overlays" ] ; then
626 626 # Setup overlays dtbs directory
627 627 mkdir "${BASEDIR}/qemu/overlays"
628 628
629 629 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
630 630 if [ -f "${dtb}" ] ; then
631 631 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
632 632 fi
633 633 done
634 634 fi
635 635
636 636 # Copy u-boot files to QEMU directory
637 637 if [ "$ENABLE_UBOOT" = true ] ; then
638 638 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
639 639 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
640 640 fi
641 641 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
642 642 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
643 643 fi
644 644 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
645 645 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
646 646 fi
647 647 fi
648 648
649 649 # Copy initramfs to QEMU directory
650 650 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
651 651 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
652 652 fi
653 653 fi
654 654
655 655 # Calculate size of the chroot directory in KB
656 656 CHROOT_SIZE=$(expr `du -s "${R}" | awk '{ print $1 }'`)
657 657
658 658 # Calculate the amount of needed 512 Byte sectors
659 659 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
660 660 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
661 661 ROOT_OFFSET=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS})
662 662
663 663 # The root partition is EXT4
664 664 # This means more space than the actual used space of the chroot is used.
665 665 # As overhead for journaling and reserved blocks 35% are added.
666 666 ROOT_SECTORS=$(expr $(expr ${CHROOT_SIZE} + ${CHROOT_SIZE} \/ 100 \* 35) \* 1024 \/ 512)
667 667
668 668 # Calculate required image size in 512 Byte sectors
669 669 IMAGE_SECTORS=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS})
670 670
671 671 # Prepare image file
672 672 if [ "$ENABLE_SPLITFS" = true ] ; then
673 673 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=${TABLE_SECTORS}
674 674 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek=${FRMW_SECTORS}
675 675 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=${TABLE_SECTORS}
676 676 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek=${ROOT_SECTORS}
677 677
678 678 # Write firmware/boot partition tables
679 679 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
680 680 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
681 681 EOM
682 682
683 683 # Write root partition table
684 684 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
685 685 ${TABLE_SECTORS},${ROOT_SECTORS},83
686 686 EOM
687 687
688 688 # Setup temporary loop devices
689 689 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME-frmw.img)"
690 690 ROOT_LOOP="$(losetup -o 1M -f --show $IMAGE_NAME-root.img)"
691 691 else # ENABLE_SPLITFS=false
692 692 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=${TABLE_SECTORS}
693 693 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek=${IMAGE_SECTORS}
694 694
695 695 # Write partition table
696 696 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
697 697 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
698 698 ${ROOT_OFFSET},${ROOT_SECTORS},83
699 699 EOM
700 700
701 701 # Setup temporary loop devices
702 702 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME.img)"
703 703 ROOT_LOOP="$(losetup -o 65M -f --show $IMAGE_NAME.img)"
704 704 fi
705 705
706 706 if [ "$ENABLE_CRYPTFS" = true ] ; then
707 707 # Create dummy ext4 fs
708 708 mkfs.ext4 "$ROOT_LOOP"
709 709
710 710 # Setup password keyfile
711 711 touch .password
712 712 chmod 600 .password
713 713 echo -n ${CRYPTFS_PASSWORD} > .password
714 714
715 715 # Initialize encrypted partition
716 716 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
717 717
718 718 # Open encrypted partition and setup mapping
719 719 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
720 720
721 721 # Secure delete password keyfile
722 722 shred -zu .password
723 723
724 724 # Update temporary loop device
725 725 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
726 726
727 727 # Wipe encrypted partition (encryption cipher is used for randomness)
728 728 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count=$(blockdev --getsz "${ROOT_LOOP}")
729 729 fi
730 730
731 731 # Build filesystems
732 732 mkfs.vfat "$FRMW_LOOP"
733 733 mkfs.ext4 "$ROOT_LOOP"
734 734
735 735 # Mount the temporary loop devices
736 736 mkdir -p "$BUILDDIR/mount"
737 737 mount "$ROOT_LOOP" "$BUILDDIR/mount"
738 738
739 739 mkdir -p "$BUILDDIR/mount/boot/firmware"
740 740 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
741 741
742 742 # Copy all files from the chroot to the loop device mount point directory
743 743 rsync -a "${R}/" "$BUILDDIR/mount/"
744 744
745 745 # Unmount all temporary loop devices and mount points
746 746 cleanup
747 747
748 748 # Create block map file(s) of image(s)
749 749 if [ "$ENABLE_SPLITFS" = true ] ; then
750 750 # Create block map files for "bmaptool"
751 751 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
752 752 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
753 753
754 754 # Image was successfully created
755 755 echo "$IMAGE_NAME-frmw.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
756 756 echo "$IMAGE_NAME-root.img ($(expr \( ${TABLE_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
757 757 else
758 758 # Create block map file for "bmaptool"
759 759 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
760 760
761 761 # Image was successfully created
762 762 echo "$IMAGE_NAME.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
763 763
764 764 # Create qemu qcow2 image
765 765 if [ "$ENABLE_QEMU" = true ] ; then
766 766 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
767 767 QEMU_SIZE=16G
768 768
769 769 qemu-img convert -f raw -O qcow2 $IMAGE_NAME.img $QEMU_IMAGE.qcow2
770 770 qemu-img resize $QEMU_IMAGE.qcow2 $QEMU_SIZE
771 771
772 772 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
773 773 fi
774 774 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant